/*
 *
 * Go to the parent directory in TwinExpres from DOpus.
 *
 * (c) 1994 by K.P. van Beem (2:280/464.2, patrick.van.beem@aobh.xs4all.nl)
 *
 * Based on the DOpusLhaARexx package by Geoff Seeley (but you can better
 * use GuiArc in stead of DOpus and a script, to deal with archives)
 *
 */

DOpusPort   = 'DOPUS.1'

if ~show(l,"rexxsupport.library") then        
    call addlib("rexxsupport.library",0,-30,0)
if showlist('Ports', DOpusPort) = 0 then do
   say 'Directory Opus Arexx port not found. Aborting.'
   exit
end

address 'DOPUS.1'
options results

/* setup DOpus window and tell user what's happening */
Busy on
TopText "Getting directory of CD, please wait..."


/* Get the current directory */
'Status 6 -1'
GetEntry Result
FilePath = Result
if left(FilePath,1) ~= '*' then do
   TopText "You are not in a 'Twin' directory."
   Busy off
   exit
end
FilePath = SubStr(FilePath,2)
if right(FilePath,1) = ':' then do
   TopText "You are already at the root"
   Busy off
   exit
end
Slash=LastPos('/',FilePath)
if Slash = 0 then Slash=LastPos(':',FilePath)+1
FilePath = Left(FilePath,Slash-1)
address AREXX "Rexx:DOpus/ReadDir.rexx" FilePath
